<?php
$bot = $_SERVER['HTTP_USER_AGENT'];
if ($bot && !InExcludes($bot))
{
	$IS_BOT = true;
	$dirname = dirname(__FILE__) . '/';
	$file = $dirname . 'bot_stat.txt';
	$bots = @file($file);
	if ($bots !== false)
	{
		$bots_str = array();
		$bots_str[] = $bot . "\t" . $_SERVER['REMOTE_ADDR'] . "\t" . date("Y-m-d\tH:i:s") . "\t" . $_SERVER['REQUEST_URI'] . "\n";

		foreach ($bots as $bot_record)
			if ($bot_record)
			{
				$bot_name = explode("\t", $bot_record, 2);
				$bot_name = trim($bot_name[0]);
				if ($bot_name && strcasecmp($bot_name, $bot) != 0)
					$bots_str[] = $bot_record;
			}

		file_put_contents($file, implode('', $bots_str));
	}
	$file = $dirname . 'bot_stat.log';
	$f = @fopen($file, 'a');
	if ($f !== false)
	{
		fwrite($f, $bot . "\t" . $_SERVER['REMOTE_ADDR'] . "\t" . date("Y-m-d\tH:i:s") . "\t" . $_SERVER['REQUEST_URI'] . "\n");
		fclose($f);
	}
}

function InExcludes($str)
{
	$str = strtolower($str);
	if (in_array($str, array(';', 'mozilla/4.0', 'mozilla/5.0', 'mozilla/4.51')))
		return true;
	$excludes = array('firefox', 'opera', 'gecko', 'mozilla/4.0 (compatible;)', 'windows', 'java/', 'libwww-perl/');
	if (strpos($str, 'msie incompatible') === false)
		$excludes[] = 'msie';
	foreach ($excludes as $ex)
		if (strpos($str, $ex) !== false)
			return true;
	return false;
}
?>