<?

/*
// +--------------------------------------------------------------------------+
// | Project:    TBDevYSE - TBDev Yuna Scatari Edition                        |
// +--------------------------------------------------------------------------+
// | This file is part of TBDevYSE. TBDevYSE is based on TBDev,               |
// | originally by RedBeard of TorrentBits, extensively modified by           |
// | Gartenzwerg.                                                             |
// |                                                                          |
// | TBDevYSE is free software; you can redistribute it and/or modify         |
// | it under the terms of the GNU General Public License as published by     |
// | the Free Software Foundation; either version 2 of the License, or        |
// | (at your option) any later version.                                      |
// |                                                                          |
// | TBDevYSE is distributed in the hope that it will be useful,              |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
// | GNU General Public License for more details.                             |
// |                                                                          |
// | You should have received a copy of the GNU General Public License        |
// | along with TBDevYSE; if not, write to the Free Software Foundation,      |
// | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA            |
// +--------------------------------------------------------------------------+
// |                                               Do not remove above lines! |
// +--------------------------------------------------------------------------+
*/

require_once("include/bittorrent.php");

function bark($msg) {
	stderr(" ", $msg);
}

dbconn();

loggedinorreturn();

if (!mkglobal("email:oldpassword:chpassword:passagain"))
	bark("missing form data");

// $set = array();

$updateset = array();
$changedemail = 0;

if ($chpassword != "") {
	if (strlen($chpassword) > 40)
		bark("Spiacenti, la tua password e troppo lungo (massimo 40 caratteri)");
	if ($chpassword != $passagain)
		bark("Le password non corrispondono. Prova di nuovo.");
    if ($CURUSER["passhash"] != md5($CURUSER["secret"] . $oldpassword . $CURUSER["secret"]))
            bark("Hai inserito non corretto, vecchio password.");

	$sec = mksecret();
	$passhash = md5($sec . $chpassword . $sec);
	$updateset[] = "secret = " . sqlesc($sec);
	$updateset[] = "passhash = " . sqlesc($passhash);
	logincookie($CURUSER["id"], $passhash);
}

if ($email != $CURUSER["email"]) {
	if (!validemail($email))
		bark("Non e come un vero E-Mail.");
  $r = sql_query("SELECT id FROM users WHERE email=" . sqlesc($email)) or sqlerr(__FILE__, __LINE__);
	if (mysql_num_rows($r) > 0)
		bark("Questo indirizzo e-mail e gia in uso da un utente di tracker. (<b>$email</b>)");
	$changedemail = 1;
}

$acceptpms = $_POST["acceptpms"];
$reception = htmlspecialchars($_POST["reception"]);
$return = htmlspecialchars($_POST["return"]);
$deletepms = ($_POST["deletepms"] != "" ? "yes" : "no");
$savepms = ($_POST["savepms"] != "" ? "yes" : "no");
$seedbox = ($_POST["seedbox"] != "" ? "yes" : "no");
$pmnotif = $_POST["pmnotif"];
$emailnotif = $_POST["emailnotif"];
$notifs = ($pmnotif == 'yes' ? "[pm]" : "");
$notifs .= ($emailnotif == 'yes' ? "[email]" : "");
$r = sql_query("SELECT id FROM categories") or sqlerr(__FILE__, __LINE__);
$rows = mysql_num_rows($r);
for ($i = 0; $i < $rows; ++$i)
{
	$a = mysql_fetch_assoc($r);
	if ($_POST["cat$a[id]"] == 'yes')
	  $notifs .= "[cat$a[id]]";
}
$avatar = $_POST["avatar"];
// Check remote avatar size
        if ($avatar) {
                if (!preg_match('#^((http)|(ftp):\/\/[a-zA-Z0-9\-]+?\.([a-zA-Z0-9\-]+\.)+[a-zA-Z]+(:[0-9]+)*\/.*?\.(gif|jpg|jpeg|png)$)#is', $avatar))
                        stderr($tracker_lang['error'], $tracker_lang['avatar_adress_invalid']);
                if(!(list($width, $height) = getimagesize($avatar)))
                        stderr($tracker_lang['error'], $tracker_lang['avatar_adress_invalid']);
                if ($width > $avatar_max_width || $height > $avatar_max_height)
                        stderr($tracker_lang['error'], sprintf($tracker_lang['avatar_is_too_big'], $avatar_max_width, $avatar_max_height));
        }
// Check remote avatar size
$avatars = ($_POST["avatars"] != "" ? "yes" : "no");
$parked = $_POST["parked"];
$updateset[] = "parked = " . sqlesc($parked);
$gender = $_POST["gender"];
$updateset[] = "gender =  " . sqlesc($gender);

$theme = $_POST["theme"];

if (is_theme($theme))
	$updateset[] = "theme = ".sqlesc($theme);

///////////////// BIRTHDAY MOD /////////////////////
$year = $_POST["year"];
$month = $_POST["month"];
$day = $_POST["day"];
$birthday = date("$year.$month.$day");
///////////////// BIRTHDAY MOD /////////////////////
$updateset[] = "birthday = " . sqlesc($birthday);

if ($_POST['resetpasskey'])
	$updateset[] = "passkey=''";

$updateset[] = "passkey_ip = ".($_POST["passkey_ip"] != "" ? sqlesc(getip()) : "''");

// $ircnick = $_POST["ircnick"];
// $ircpass = $_POST["ircpass"];
$info = $_POST["info"];
$stylesheet = $_POST["stylesheet"];
$country = $_POST["country"];
$language = $_POST["language"];
if (!file_exists('./languages/lang_'.$language.'/lang_main.php')) {
    bark('La lingua selezionata non e nel sistema!');
}
$updateset[] = "language = " . sqlesc($language);
//$timezone = 0 + $_POST["timezone"];
//$dst = ($_POST["dst"] != "" ? "yes" : "no");

$tvmonik = unesc($_POST["tvmonik"]);
if (strlen($tvmonik) > 503)
    bark("Pieta, Numero di Monitor troppo lungo  (Max- 50)");

$hdplayer = unesc($_POST["hdplayer"]);
if (strlen($hdplayer) > 503)
    bark("Pieta, Il vostro nome di HD player troppo lungo  (Max- 50)");

$lettoreray = unesc($_POST["lettoreray"]);
if (strlen($lettoreray) > 504)
    bark("Pieta, Il vostro nome di lettore troppo lungo  (Max- 50)");

$ps3 = unesc($_POST["ps3"]);
if (strlen($ps3) > 504)
    bark("Pieta, Il vostro nome di PS3 troppo lungo  (Max- 50)");

$pc = unesc($_POST["pc"]);
if (strlen($pc) > 504)
    bark("Pieta, Il vostro descrizione del PC  troppo lungo  (Max- 50)");

$icq = (int) unesc($_POST["icq"]);
if (strlen($icq) > 10)
    bark("Peccato, numero di icq troppo lungo  (Max - 10)");
$updateset[] = "icq = " . sqlesc($icq);

$msn = unesc($_POST["msn"]);
if (strlen($msn) > 30)
    bark("Peccato, Vostro msn troppo lungo  (Max - 30)");
$updateset[] = "msn = " . sqlesc(htmlspecialchars($msn));

$aim = unesc($_POST["aim"]);
if (strlen($aim) > 30)
    bark("Peccato, Vostro aim troppo lungo  (Max - 30)");
$updateset[] = "aim = " . sqlesc(htmlspecialchars($aim));

$yahoo = unesc($_POST["yahoo"]);
if (strlen($yahoo) > 30)
    bark("Peccato, Vostro yahoo troppo lungo  (Max - 30)");
$updateset[] = "yahoo = " . sqlesc(htmlspecialchars($yahoo));

$mirc = unesc($_POST["mirc"]);
if (strlen($mirc) > 30)
    bark("Peccato, Vostro mirc troppo lungo  (Max - 30)");
$updateset[] = "mirc = " . sqlesc(htmlspecialchars($mirc));

$skype = unesc($_POST["skype"]);
if (strlen($skype) > 20)
    bark("Peccato, Vostro skype troppo lungo  (Max - 20)");
$updateset[] = "skype = " . sqlesc(htmlspecialchars($skype));

/*
if ($privacy != "normal" && $privacy != "low" && $privacy != "strong")
	bark("whoops");

$updateset[] = "privacy = '$privacy'";
*/

$website = unesc($_POST["website"]);
$updateset[] = "website = " . sqlesc(htmlspecialchars_uni($website));
$facebook = unesc($_POST["facebook"]);
$updateset[] = "facebook = " . sqlesc(htmlspecialchars_uni($facebook));

$updateset[] = "torrentsperpage = " . min(100, 0 + $_POST["torrentsperpage"]);
$updateset[] = "topicsperpage = " . min(100, 0 + $_POST["topicsperpage"]);
$updateset[] = "postsperpage = " . min(100, 0 + $_POST["postsperpage"]);

if (is_valid_id($stylesheet))
  $updateset[] = "stylesheet = '$stylesheet'";
if (is_valid_id($country))
  $updateset[] = "country = $country";


//$updateset[] = "timezone = $timezone";
//$updateset[] = "dst = '$dst'";
$updateset[] = "info = " . sqlesc($info);
$updateset[] = "acceptpms = " . sqlesc($acceptpms);
$updateset[] = "deletepms = '$deletepms'";
$updateset[] = "savepms = '$savepms'";
$updateset[] = "seedbox = '$seedbox'";
$updateset[] = "notifs = '$notifs'";
$updateset[] = "avatar = " . sqlesc($avatar);
$updateset[] = "avatars = '$avatars'";

$updateset[] = "tvmonik = '$tvmonik'";
$updateset[] = "hdplayer = '$hdplayer'";
$updateset[] = "lettoreray = '$lettoreray'";
$updateset[] = "ps3 = '$ps3'";
$updateset[] = "pc = '$pc'";
$updateset[] = "reception = " . sqlesc($reception);
$updateset[] = "priem = " . sqlesc($return);
/* ****** */

$urladd = "";

if ($changedemail) {
	$sec = mksecret();
	$hash = md5($sec . $email . $sec);
	$obemail = urlencode($email);
	$updateset[] = "editsecret = " . sqlesc($sec);
	$thishost = $_SERVER["HTTP_HOST"];
	$thisdomain = preg_replace('/^www\./is', "", $thishost);
	$body = <<<EOD
You have requested that your user profile (username {$CURUSER["username"]})
on $thisdomain should be updated with this email address ($email) as
user contact.

If you did not do this, please ignore this email. The person who entered your
email address had the IP address {$_SERVER["REMOTE_ADDR"]}. Please do not reply.

To complete the update of your user profile, please follow this link:

http://$thishost/confirmemail.php?id={$CURUSER["id"]}&hash=$hash&email=$obemail

If you have AOL browser, please click the following link:
<a href="http://$thishost/confirmemail.php?id={$CURUSER["id"]}&amp;hash=$hash&amp;email=$obemail">http://$thishost/confirmemail.php?id={$CURUSER["id"]}&amp;hash=$hash&amp;email=$obemail</a>

Your new email address will appear in your profile after you do this. Otherwise
your profile will remain unchanged.
EOD;

	sent_mail($email, $SITENAME, $SITEEMAIL, "Modificare le impostazioni del profilo per $thisdomain", $body, false);
//	mail($email, "$thisdomain profile change confirmation", $body, "From: $SITEEMAIL");
	$urladd .= "&mailsent=1";
}

sql_query("UPDATE users SET " . implode(",", $updateset) . " WHERE id = " . $CURUSER["id"]) or sqlerr(__FILE__,__LINE__);

header("Location: $DEFAULTBASEURL/my.php?edited=1" . $urladd);

?>