<?php

/*
// +--------------------------------------------------------------------------+
// | Project:    TBDevYSE - TBDev Yuna Scatari Edition                        |
// +--------------------------------------------------------------------------+
// | This file is part of TBDevYSE. TBDevYSE is based on TBDev,               |
// | originally by RedBeard of TorrentBits, extensively modified by           |
// | Gartenzwerg.                                                             |
// |                                                                          |
// | TBDevYSE is free software; you can redistribute it and/or modify         |
// | it under the terms of the GNU General Public License as published by     |
// | the Free Software Foundation; either version 2 of the License, or        |
// | (at your option) any later version.                                      |
// |                                                                          |
// | TBDevYSE is distributed in the hope that it will be useful,              |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
// | GNU General Public License for more details.                             |
// |                                                                          |
// | You should have received a copy of the GNU General Public License        |
// | along with TBDevYSE; if not, write to the Free Software Foundation,      |
// | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA            |
// +--------------------------------------------------------------------------+
// |                                               Do not remove above lines! |
// +--------------------------------------------------------------------------+
*/

require "include/bittorrent.php";

dbconn();
loggedinorreturn();

$id = (int) $_GET["torrent"];

$res = sql_query("SELECT torrents.seeders, torrents.banned, torrents.leechers, torrents.name, torrents.filename, torrents.times_completed, torrents.id, UNIX_TIMESTAMP(torrents.last_reseed) AS lr, categories.name AS cat_name FROM torrents LEFT JOIN categories ON torrents.category = categories.id WHERE torrents.id = $id") or sqlerr(__FILE__, __LINE__);
$row = mysql_fetch_array($res);

if (!$row || $row["banned"] == "yes")
	stderr($tracker_lang['error'], $tracker_lang['no_torrent_with_such_id']);

if ($row["times_completed"] == 0)
	stderr($tracker_lang['error'], "Ci dispiace, ma questo torrente non e stato scaricato da nessuno.");

if ($row["leechers"] == 0)
	stderr($tracker_lang['error'], "Questo release non ha bisogno di aiuto perche nonche nessuno chi scarica.");

$dt = time() - 24*3600;

if ($row["lr"] > $dt && get_date_time($row["lr"]) != "0000-00-00 00:00:00")
	stderr($tracker_lang['error'], "Ci dispiace, ma non sono ancora stati giorni da quando l'ultima query restituira alla distribuzione.");

$subject = sqlesc("Aiutate distribuire (seeding) {$row["name"]}");

$msg = sqlesc("Ciao!

Il vostro aiuto e necessario in distribuzione [url=details.php?id={$id}]{$row["cat_name"]} :: {$row["name"]}[/url]
Se si decide di aiutare, ma gia eliminato il file torrent, e possibile scaricarlo [url=download.php?id=$id&name=" . rawurlencode($row["filename"]) . "]qui[/url].

Spero per il vostro aiuto!");

sql_query("INSERT INTO messages (sender, receiver, poster, added, subject, reseed, msg) SELECT $CURUSER[id], userid, 0, NOW(), $subject, 'yes', $msg FROM snatched WHERE torrent = $id AND userid != $CURUSER[id] AND finished = 'yes'") or sqlerr(__FILE__, __LINE__);
sql_query("UPDATE torrents SET last_reseed = NOW() WHERE id = $id") or sqlerr(__FILE__, __LINE__);
header("Refresh: 2; url=details.php?id=$id");

stdhead("Chiamare chi scaricato torrent sul release $row[name]");
stdmsg("Successo", "La tua richiesta di reseed, che hanno scaricato e fatta. Aspetta i risultati in pochi giorni, altrimenti ripetere la richiesta.");
stdfoot();

?>