 <?php
 // This version created by SteveaS steveas.by
 class parsimdb {
 	private $url = false;
 	private $response = false;
 	public function int ( $link ) {
 		$this->url = $link;
 		$this->get_page();
 	}
 	private function get_page() {
		$cl = curl_init();
		curl_setopt( $cl, CURLOPT_URL, $this->url );
		curl_setopt( $cl, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $cl, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.1599.66 Safari/537.36 SUSE/30.0.1599.66" );
		curl_setopt( $cl, CURLOPT_COOKIESESSION, true );
		curl_setopt( $cl, CURLOPT_FRESH_CONNECT, true );
		curl_setopt( $cl, CURLOPT_CONNECTTIMEOUT, 15 );
		curl_setopt( $cl, CURLOPT_TIMEOUT, 15 );
		$this->response = curl_exec ( $cl );
		curl_close( $cl );
	}
	public function preg_tag() {
		preg_match_all ( "/\<span class=\"itemprop\" itemprop=\"genre\"\>([a-zA-Z]+)\<\/span\>/", $this->response, $arr );
//		preg_match ( "/\<meta property='og:type' content=\"(.*?)\" \/\>/", $this->response, $type ); // Type
//		preg_match ( "/\<a href=\"\/year\/([0-9]+)\/\?ref_=tt_ov_inf\" \>[0-9]+\<\/a\>/", $this->response, $year ); // Year
//		preg_match ( "/\<span itemprop=\"creator\" itemscope itemtype=\"http:\/\/schema\.org\/Organization\"\>[\s]+\<a href=\"\/company\/.*?\" itemprop='url'\>\<span class=\"itemprop\" itemprop=\"name\"\>(.*?)\<\/span\>\<\/a\>\<\/span\>/", $this->response, $studio ); // Studio
		$res = array( "genr" => $arr[1] );
		return $res;
	}
	private function imdbStar($dbl) {
		switch ($dbl) {
			case 1:
				return 9;
				break;
			case 2:
				return 8;
				break;
			case 3:
				return 7;
				break;
			case 4:
				return 6;
				break;
			case 5:
				return 5;
				break;
			case 6:
				return 4;
				break;
			case 7:
				return 4;
				break;
			case 8:
				return 3;
				break;
			case 9:
				return 2;
				break;
		} 
	} 
	public function imdb($torrentid, $imdbid) {
		////INT////
		$pic = imagecreatefrompng ( "pic/imdb/back.png" );
		$star = imagecreatefrompng ( "pic/imdb/star.png" );
		imagealphablending ( $pic, true );
		////INT////
		////PREG////
		preg_match ( "/\<span itemprop=\"ratingValue\"\>([0-9]{1,2})\.([0-9]{1,2})\<\/span\>\<\/strong\>/", $this->response, $ratio );
		preg_match ( "/\<span itemprop=\"ratingCount\"\>(.*?)\<\/span\>/", $this->response, $votes );
		preg_match ( "/\<img height=\"[0-9]+\"[\s]+width=\"[0-9]+\"[\s]+alt=\".*?\"[\s]+title=\".*?\"[\s]+src=\"(.*?)\"[\s]+itemprop=\"image\" \/\>/", $this->response, $poster );
		$ratio_full = $ratio[1] . "." . $ratio[2];
		////PREG////
		imagestring($pic, 2, 86 - (strlen($ratio_full)-1) * 7, 1, $ratio_full, imagecolorallocate($pic, 0, 0, 0));
		imagestring($pic, 1, 82 - (strlen($votes[1])-2) * 5, 17, $votes[1], imagecolorallocate($pic, 157, 157, 157));
		for ( $i = 0, $next = 0; $i != (int)$ratio_full; $i++, $next = $next + 10 ) {
			imagecopy ( $pic, $star, 1 + $next, 25, 0, 0, imagesx($star), imagesy($star));
		}
		if ( $ratio[2] != 0 )
			imagecopy($pic, $star, 1 + $next, 25, 0, 0, imagesx($star) - $this->imdbStar($ratio[2]), imagesy($star));


		@unlink("torrents/imdb/" . $torrentid . "_" . $imdbid . ".png");
		imagepng($pic, "torrents/imdb/" . $torrentid . "_" . $imdbid . ".png"); 
		return array( "ratio" => $ratio[1] . $ratio[2], "votes" => preg_replace( "/([\.\,]+)/", "", $votes[1] ), "poster" => $poster[1] );
	}

}
