var panelID;
var numDiv;
var tabHeight = 30;

var current_tab = 0;

function getDiv(s,i)
{
	return document.getElementById(panelID + s + i);
}

function setZIndex(div, zIndex)
{
	div.style.zIndex = zIndex;
}

function selectTab(obj) 
{
	var n = obj.id ? obj.id.substr(obj.id.length - 1, 1) : obj;
	current_tab = -1;
	for (var i = 0; i < numDiv; ++i)
	{
		var div = getDiv("tab", i);
		if (i == n)
			select(div);
		else
			leave(div);
		div = getDiv("panel", i);
		setZIndex(div, i == n ? numDiv + 1 : i);
		div.style.visibility = i == n ? "visible" : "hidden";
	}
	current_tab = n;
}

function select(obj)
{
	do_highlight(obj, 'white', '#404040', 'red');
}

function hover(obj)
{
	do_highlight(obj, '#ffffe8', '#787870', '#a04040');
}

function leave(obj)
{
	do_highlight(obj, '#303030', 'white', '#404040');
}

function do_highlight(obj, color, backcolor, topborder)
{
	if (obj.id.substr(obj.id.length - 1, 1) != current_tab)
	{
		obj.style.color = color;
		obj.style.background = backcolor;
		obj.style.borderTopColor = topborder;
	}
}

function Init(controlname, count, height_percent)
{
	panelID = controlname;
	numDiv = count;
	selectTab(0);
	getDiv("tab", 0).style.borderLeft = "2px solid #404040";
	getDiv("tab", numDiv - 1).style.borderRight = "2px solid #404040";
	if (height_percent != 0)
	{
		getDiv("", "").style.height = (height_percent/100 * window.screen.availHeight) + "px";
		getDiv("footer", "").style.top = (height_percent/100 * window.screen.availHeight - tabHeight) + "px";
	}
}
