<?

/*
// +--------------------------------------------------------------------------+
// | Project:    TBDevYSE - TBDev Yuna Scatari Edition                        |
// +--------------------------------------------------------------------------+
// | This file is part of TBDevYSE. TBDevYSE is based on TBDev,               |
// | originally by RedBeard of TorrentBits, extensively modified by           |
// | Gartenzwerg.                                                             |
// |                                                                          |
// | TBDevYSE is free software; you can redistribute it and/or modify         |
// | it under the terms of the GNU General Public License as published by     |
// | the Free Software Foundation; either version 2 of the License, or        |
// | (at your option) any later version.                                      |
// |                                                                          |
// | TBDevYSE is distributed in the hope that it will be useful,              |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
// | GNU General Public License for more details.                             |
// |                                                                          |
// | You should have received a copy of the GNU General Public License        |
// | along with TBDevYSE; if not, write to the Free Software Foundation,      |
// | Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA            |
// +--------------------------------------------------------------------------+
// |                                               Do not remove above lines! |
// +--------------------------------------------------------------------------+
*/

require_once("include/bittorrent.php");

dbconn();

if ($deny_signup && !$allow_invite_signup)
	stderr($tracker_lang['error'], "Ci dispiace, ma la registrazione e disattivata per il Amministrazione.");

if ($CURUSER)
	stderr($tracker_lang['error'], sprintf($tracker_lang['signup_already_registered'], $SITENAME));

$users = get_row_count("users");
if ($users >= $maxusers)
	stderr($tracker_lang['error'], sprintf($tracker_lang['signup_users_limit'], number_format($maxusers)));

if (!mkglobal("wantusername:wantpassword:passagain:email"))
	stderr($tracker_lang['error'], "Accesso diretto al file non e consentito.");

if($_POST['seedbox'] == "yes") {
	$seedbox = $_POST['seedbox'];
} else {
	if ($deny_signup && $allow_invite_signup) {
	if (empty($_POST["invite"]))
		stderr("Errore", "Per la registrazione e necessario inserire un codice di invito!");
	if (strlen($_POST["invite"]) != 32)
		stderr("Errore", "Non hai inserito un codice di invito valido.");
	list($inviter) = mysql_fetch_row(sql_query("SELECT inviter FROM invites WHERE invite = ".sqlesc($_POST["invite"])));
	if (!$inviter)
		stderr("Errore", "Il codice di invito che hai inserito non funziona.");
	list($invitedroot) = mysql_fetch_row(sql_query("SELECT invitedroot FROM users WHERE id = $inviter"));
} 

}

#die($seedbox . "s" . $_POST['gender']);

function bark($msg) {
	global $tracker_lang;
	stdhead();
	stdmsg($tracker_lang['error'], $msg, 'error');
	stdfoot();
	exit;
}

function validusername($username)
{
	if ($username == "")
	  return false;

	// The following characters are allowed in user names
	$allowedchars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_".
		"Ũ";

	for ($i = 0; $i < strlen($username); ++$i)
	  if (strpos($allowedchars, $username[$i]) === false)
	    return false;

	return true;
}

$gender = $_POST["gender"];
$website = htmlspecialchars_uni($_POST["website"]);
$facebook = htmlspecialchars_uni($_POST["facebook"]);
$country = $_POST["country"];
$year = $_POST["year"];
$month = $_POST["month"];
$day = $_POST["day"];




$tvmonik = unesc($_POST["tvmonik"]);
if (strlen($tvmonik) > 50)
    bark("Pieta, nome troppo lungo  (Max- 50)");

$hdplayer = unesc($_POST["hdplayer"]);
if (strlen($hdplayer) > 50)
    bark("Pieta, Il nome troppo lungo  (Max- 50)");

$lettoreray = unesc($_POST["lettoreray"]);
if (strlen($lettoreray) > 50)
    bark("Pieta, Il nome troppo lungo  (Max- 50)");

$ps3 = unesc($_POST["ps3"]);
if (strlen($ps3) > 50)
    bark("Pieta, Il descrizione troppo lungo  (Max- 50)");

$pc = unesc($_POST["pc"]);
if (strlen($pc) > 50)
    bark("Pieta, Il vostro descrizione troppo lungo  (Max- 50)");

	
	
	
	
	
	
	

$icq = unesc($_POST["icq"]);
if (strlen($icq) > 10)
    bark("Pieta, Numero icq troppo lungo  (Max- 10)");

$msn = unesc($_POST["msn"]);
if (strlen($msn) > 30)
    bark("Pieta, Il vostro msn troppo lungo  (Max- 30)");

$aim = unesc($_POST["aim"]);
if (strlen($aim) > 30)
    bark("Pieta, Il vostro aim troppo lungo  (Max- 30)");

$yahoo = unesc($_POST["yahoo"]);
if (strlen($yahoo) > 30)
    bark("Pieta, Il vostro yahoo troppo lungo  (Max- 30)");

$mirc = unesc($_POST["mirc"]);
if (strlen($mirc) > 30)
    bark("Pieta, Il vostro mirc troppo lungo  (Max- 30)");

$skype = unesc($_POST["skype"]);
if (strlen($skype) > 20)
    bark("Pieta, Il vostro skype troppo lungo  (Max- 20)");

if (empty($wantusername) || empty($wantpassword) || empty($email) || empty($gender) || empty($country))
	bark("Tutti i campi sono obbligatori da compilare.");

if (strlen($wantusername) > 12)
	bark("Siamo spiacenti, il nome utente e troppo lungo (Maximum 12 caratteri)");

if ($wantpassword != $passagain)
	bark("Le password non coincidono! Sembra che hai fatto un errore. Prova ancora.");

if (strlen($wantpassword) < 6)
	bark("Siamo spiacenti, la password e troppo corto (minimum di 6 caratteri)");

if (strlen($wantpassword) > 40)
	bark("Siamo spiacenti, la password e troppo lungo (Maximum 40 caratteri)");

if ($wantpassword == $wantusername)
	bark("Spiacente, la password non puo essere tale lo stesso nome utente.");

$email = trim($email);

if (!validemail($email))
	bark("Non e come un indirizzo email reale.");

if (!validusername($wantusername))
	bark("Login non valido.");

if ($year=='0000' || $month=='00' || $day=='00')
        stderr($tracker_lang['error'],"Sembra che hai inserito la data di nascita errata");
	$birthday = date("$year.$month.$day");

// make sure user agrees to everything...
if ($_POST["rulesverify"] != "yes" || $_POST["faqverify"] != "yes" || $_POST["ageverify"] != "yes")
	stderr($tracker_lang['error'], "Spiacente, non sono ammissibili per questo di diventare membro di questo sito.");

// check if email addy is already in use
$a = (@mysql_fetch_row(@sql_query("SELECT COUNT(*) FROM users WHERE email=".sqlesc($email)))) or die(mysql_error());
if ($a[0] != 0)
	bark("E-mail indirizzo ".htmlspecialchars($email)." gia registrato nel sistema.");

if ($use_captcha) {
	$b = get_row_count("captcha", "WHERE imagehash = ".sqlesc($_POST["imagehash"])." AND imagestring = ".sqlesc($_POST["imagestring"]));
	sql_query("DELETE FROM captcha WHERE imagehash = ".sqlesc($_POST["imagehash"])) or die(mysql_error());
	if ($b == 0)
		bark("Hai inserito un codice di verifica errato.");
}

$ip = getip();

$secret = mksecret();
$wantpasshash = md5($secret . $wantpassword . $secret);
$editsecret = (!$users?"":mksecret());

if ((!$users) || (!$use_email_act == true))
	$status = 'confirmed';
else
	$status = 'pending';

$language = 'italian';

$reception = htmlspecialchars($_POST["reception"]);
$return = htmlspecialchars($_POST["return"]);


$ret = sql_query("INSERT INTO users (reception, priem, username, passhash, secret, editsecret, gender, country, icq, msn, aim, yahoo, skype, mirc, tvmonik, hdplayer, lettoreray, ps3, pc, website, facebook, email, status, language, seedbox, ". (!$users?"class, ":"") ."added, birthday, invitedby, invitedroot) VALUES (" .
		implode(",", array_map("sqlesc", array($reception, $return, $wantusername, $wantpasshash, $secret, $editsecret, $gender, $country, $icq, $msn, $aim, $yahoo, $skype, $mirc, $tvmonik, $hdplayer, $lettoreray, $ps3, $pc, $website, $facebook, $email, $status, $language, $seedbox))).
		", ". (!$users?UC_SYSOP.", ":""). "'". get_date_time() ."', '$birthday', '$inviter', '$invitedroot')");// or sqlerr(__FILE__, __LINE__);

if (!$ret) {
	if (mysql_errno() == 1062)
		bark("Utente $wantusername gia registrato!");
	bark(" .    mySQL: ".htmlspecialchars(mysql_error()));
}

$id = mysql_insert_id();

if($_POST['seedbox'] != "yes") {

sql_query("DELETE FROM invites WHERE invite = ".sqlesc($_POST["invite"]));

}

$user_id = mysql_fetch_array(sql_query("SELECT id FROM users WHERE `username` LIKE '" . $wantusername . "' LIMIT 0 , 30"));
$id_end = $user_id[0];

write_log("Registrato nuovo utente <a href=\"userdetails.php?id=$id_end\">$wantusername</a>","FFFFFF","tracker");

$psecret = md5($editsecret);

$body = <<<EOD
Siete registrati sul $SITENAME e ha indicato questo indirizzo come il ritorno ($email).

Se non fosse per te, ti preghiamo di ignorare questa lettera. Una persona che ha inserito il tuo indirizzo di posta elettronica e il indirizzo IP {$_SERVER["REMOTE_ADDR"]}. Si prega di non rispondere.

Per confermare la registrazione, e necessario passare sul seguente link:

$DEFAULTBASEURL/confirm.php?id=$id&secret=$psecret

Una volta fatto, potete utilizzare il vostro account. Se non lo fai,
 Il tuo nuovo account saranno cancellati dopo un paio di giorni. Vi consigliamo di leggere le regole
e le FAQ prima di iniziare a utilizzare $SITENAME.
EOD;

if($use_email_act && $users) {
	sent_mail($email, $SITENAME, $SITEEMAIL,"Conferma della registrazione sul sito $SITENAME", $body, false);

} else {
	logincookie($id, $wantpasshash);
}

header("Refresh: 0; url=ok.php?type=". (!$users?"sysop":("signup&email=" . urlencode($email))));

?>